@echo off

REM
REM * ============================================================================
REM * Licensed Materials - Property of IBM
REM *  WebSphere sMash
REM *
REM * (C) Copyright IBM Corp. 2008  All Rights Reserved.
REM *
REM * US Government Users Restricted Rights - Use, duplication or disclosure
REM * restricted by GSA ADP Schedule Contract with IBM Corp.
REM * ============================================================================
REM

@setlocal

set ZERO_HOME=%~dp0.
cd /d "%ZERO_HOME%"

set ZEROCMD="%ZERO_HOME%\zero" %ZERO_MAIN_OPTS%
set ZRP=%ZERO_HOME%\.zero\private\resolved.properties

REM -----------------------------------------------------------------
REM Bootstrap the CLI if necessary.
REM -----------------------------------------------------------------

REM If the caller is using ZERO_EXIT_CMD, they really want proper exit behavior from appbuilder.bat.
REM But for our purposes, we need zero.bat to exit normally, hence the reset of ZERO_EXIT_CMD to false.
if "%ZERO_EXIT_CMD%" == "true" goto fix_exit_code
goto bootstrap

:fix_exit_code
set ZERO_EXIT_CMD=false
set AB_EXIT_CMD=true
goto bootstrap

REM Invoke a non-verbose command; allow resolve output to show progress
:bootstrap
call %ZEROCMD% bootstrap
if not %ERRORLEVEL% == 0 goto bootstrap_failed
goto invoke_script

REM -----------------------------------------------------------------
REM Invoke the zero.cli.tasks/appbuilder script.
REM -----------------------------------------------------------------

:invoke_script
set SCRIPT_HOME=
for /F "usebackq eol=; tokens=1,2* delims==" %%i in ("%ZRP%") do if %%i == zero.cli.tasks ( set SCRIPT_HOME=%%j\.)
set SCRIPT_HOME=%SCRIPT_HOME:\:=:%
set SCRIPT_HOME=%SCRIPT_HOME:\\=\%
if exist "%SCRIPT_HOME%\appbuilder.bat" goto call_script
echo could not find "%SCRIPT_HOME%\appbuilder.bat"
set EXIT_CODE=1
goto end

:call_script

call "%SCRIPT_HOME%\appbuilder.bat" %* 
set EXIT_CODE=%ERRORLEVEL%
goto end

:bootstrap_failed
echo ERROR: Failed to bootstrap CLI.  Run the zero command for more information.
goto end

:end
if "%AB_EXIT_CMD%" == "true" exit %EXIT_CODE%
exit /b %EXIT_CODE%
@endlocal
